#----------------
#-Simple-Classes-
#----------------
import es,popuplib,keyvalues

def cl_handle(userid,choice,popupname):
    player = Player(userid)
    player.Damage(userid,player.getHealth())
    SetStats(userid,choice)
    es.tell(userid,"#multi","#lightgreen[#greenSimple Classes#lightgreen] #defaultYour class is now \x05%s#default."%choice)

es.keygroupload("classes_database","eventscripts/cl")
cl_classes = keyvalues.getKeyGroup("classes_database")
cl_menu = popuplib.easymenu("cl_menu",None,cl_handle)
cl_menu.settitle("Class Selection")
for cl_class in cl_classes: cl_menu.addoption(cl_class.getName(),"%s - %s"%(cl_class.getName(),cl_classes[cl_class.getName()]["description"]))
cl_players = {}
sv = es.ServerVar("scl_version")
sv.set("1.0.0")
sv.makepublic()

class Player():
    def __init__(self,userid):
        self.userid = int(userid)
        self.exists = es.exists("userid",self.userid)
    def Give(self,item):
        if not Player(self.userid).getDead(): es.server.queuecmd("es_xgive %s %s" %(self.userid,item))
    def Damage(self,target,damage):
        self.tar = Player(target)
        if not es.exists("userid",target) or not self.exists or self.tar.getDead(): return
        health = self.tar.getHealth()
        if damage < health:
            health -= damage
            self.tar.setHealth(health)
        else:
            es.server.queuecmd("es_xgive %s point_hurt"%target)
            es.server.queuecmd('es_xfire %s !self addoutput "targetname cl_target"'%target)
            es.server.queuecmd('es_xfire %s point_hurt addoutput "targetname cl_damage"'%target)
            es.server.queuecmd('es_xfire %s cl_damage addoutput "Damage %s"'%(target,damage))
            es.server.queuecmd('es_xfire %s cl_damage addoutput "DamageType 32"'%target)
            es.server.queuecmd('es_xfire %s cl_damage addoutput "DamageTarget cl_target"'%self.userid)
            es.server.queuecmd('es_xfire %s cl_damage addoutput "ClassName %s"'%(target,Player(self.userid).getActiveWeapon()))
            es.server.queuecmd("es_xfire %s cl_damage TurnOn"%target)
            es.server.queuecmd("es_xfire %s cl_damage Hurt"%self.userid)
            es.server.queuecmd("es_xfire %s cl_damage Kill"%target)
            es.server.queuecmd('es_xfire %s !self addoutput "targetname cl_player"'%target)
    def setSpeed(self,speed):
        if not self.exists: return
        es.setplayerprop(self.userid,"CBasePlayer.localdata.m_flLaggedMovementValue",speed)
    def setHealth(self,health):
        if not self.exists: return
        es.setplayerprop(self.userid,"CBasePlayer.m_iHealth",health)
    def setArmor(self,armor):
        if not self.exists: return
        es.setplayerprop(self.userid,"CCSPlayer.m_ArmorValue",armor)
    def getSpeed(self):
        if not self.exists: return False
        return es.getplayerprop(self.userid,"CBasePlayer.localdata.m_flLaggedMovementValue")
    def getHealth(self):
        if not self.exists: return False
        return es.getplayerprop(self.userid,"CBasePlayer.m_iHealth")
    def getArmor(self):
        if not self.exists: return False
        return es.getplayerprop(self.userid,"CCSPlayer.m_ArmorValue")
    def getDead(self):
        if not self.exists: return False
        return bool(es.getplayerprop(self.userid,"CCSPlayer.baseclass.pl.deadflag"))
    def getActiveWeapon(self):
        if not self.exists: return False
        active = es.createplayerlist(self.userid)[self.userid]["weapon"]
        es.keygroupdelete(self.userid)
        if active != "": return active
        else: return "point_hurt"
    def getPlayerIndex(self):
        if not self.exists: return False
        index = es.createplayerlist(self.userid)[self.userid]["index"]
        es.keygroupdelete(self.userid)
        return index

def SetStats(userid,cl_class):
    cl_players[userid]["class"] = cl_class
    cl_players[userid]["primary"] = cl_classes[cl_class]["primary"]
    cl_players[userid]["secondary"] = cl_classes[cl_class]["secondary"]
    cl_players[userid]["health"] = int(cl_classes[cl_class]["health"])
    cl_players[userid]["speed"] = float(cl_classes[cl_class]["speed"])
    cl_players[userid]["armor"] = int(cl_classes[cl_class]["armor"])
    cl_players[userid]["damage"] = int(cl_classes[cl_class]["damage"])

def ResetStats(userid):
    userid = int(userid)
    for cl_class in cl_classes:
        cl_sclass = cl_class.getName()
        break
    cl_players[userid] = {}
    SetStats(userid,cl_sclass)

def SpawnPerks(userid):
    player = Player(userid)
    player.Give(cl_players[userid]["primary"])
    player.Give(cl_players[userid]["secondary"])
    player.setHealth(cl_players[userid]["health"])
    player.setSpeed(cl_players[userid]["speed"])
    player.setArmor(cl_players[userid]["armor"])

def AttackerPerks(userid,attacker):
    player = Player(userid)
    damage = cl_players[userid]["damage"]
    if damage > 0: player.damage(attacker,damage)

def player_spawn(ev):
    userid = int(ev["userid"])
    if userid not in cl_players: ResetStats(userid)
    if int(ev["es_userteam"]) > 1:
        SpawnPerks(userid)
        es.tell(userid,"#multi","#lightgreen[#greenSimple Classes#lightgreen] #defaultYour class is currently \x05%s#default."%cl_players[userid]["class"])

def player_hurt(ev):
    if int(ev["health"]) > 0 or ev["weapon"] == "point_hurt" or ev["userid"] == ev["attacker"]: return
    AttackerPerks(int(ev["userid"]),int(ev["attacker"]))

def player_say(ev):
    if str(ev["text"]).lower() == "!classes" or str(ev["text"]).lower() == "!class":
        userid = int(ev["userid"])
        if userid not in cl_players: ResetStats(userid)
        popuplib.send("cl_menu",userid)

def unload():
    es.keygroupdelete("classes_database")
    popuplib.delete("cl_menu")
